;--------------------------------------------------------------------------
; BiDiPro/AVR v0.1.0                      bidi12ar.asm -- BiDiPro functions
; Copyright (c) Eduard Panchenko, Alex Plusov / CnC Lab, Andrej Arnold, 2003
; Copyright (c) Oleg O. Chukaev, 2007, 2008  <oleg.chukaev@mail.ru>
;--------------------------------------------------------------------------
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
;
;--------------------------------------------------------------------------
; Changes:
;	2007-07-07	0leg	  BiDiPro/AVR  ੢
;				bidi12.drv ᨨ 1.0 (optimized)
;
;--------------------------------------------------------------------------
; ਣ ਩:
;
; Title:  BIDI12.DRV
; ਠ ࠡ⠥  ० + - ४樮.
;  ଠ쭮 ࠡ⠥  ० EPP
;      ⪮ . ਬ୮ 30.
;       ⮯  ० ४樮.
;஬ ⮣,  ࠢ ⮢  ணࠬ.
; Desc:   BiDi programmer driver for rev1.3
; Ver:	  1.2 
; Found:  01-04-2000
; Last:   09-07-2003
; CPU:	  286+
; Compil: TASM 3.1, TLINK 5.22b (DOS)
; Author: Eduard Panchenko / P.E.co.
;	  Alex Plusov / CnC Lab
;	  Andrej Arnold - ࠡ⪨/ࠡ⪨
;--------------------------------------------------------------------------


; Warning! ds not set - set/restore if need!
; if use si,di - push/pop it!
; return by ret, not retf!


; BIDI	  LPT	      REG.BITS
; WR:	  1(STROBE) - C.0
; RD:	  14(AFD)   - C.1
; A0:	  16(INIT)  - C.2
; A1:	  17(SLCT)  - C.3


global	_bdport		:near
global	_init		:near
global	_voltage	:near
global	_portaddr	:word


     model small,c
     .code
     .286

DEBUG = 0
ECPEPP = 1	;FOR ECP mode

;public	  signature

;------- Begin Driver data block --------
;signature db "HDRV",0
;ver	  db 12h	    ; version
;opinm	  dd 0FFFFFFFFH     ; output pins mask
;ipinm	  dd 0FFFFFFFFH     ; input pins  mask
;portadr   dw 0		    ; hardware port adr - set by main program
;msdelay   dd 0		    ; void msdelay (word delay)  pointer to C subroutine "delay" from main
;mcsdelay  dd 0		    ; void mcsdelay (word delay) pointer to C subroutine "delay" from main

;	  dw offset init    ; int  init(void);
;	  dw offset bdport  ; word bdport (word cmd);
;	  dw offset setpin  ; int  setpin (word pin,word state);
;	  dw offset getpin  ; byte getpin (word pin);
;	  dw offset voltage ; int voltage (word Vcc,word Vpp,word Vid)
;	  dw offset VccTable
;	  dw offset VppTable
;	  dw offset VidTable

;------- End Driver data block --------

VccTable dw   4   ; ࠧ ⠡
	 dw   45,50,55,60,0
VppTable dw   32  ; ࠧ ⠡
	 dw    55, 65, 75, 85
	 dw    95,105,110,115
	 dw   120,125,130,135
	 dw   140,145,150,155
	 dw   160,165,170,175
	 dw   180,185,190,195
	 dw   200,205,210,220
	 dw   230,240,250,260
VidTable dw   2  ; ࠧ ⠡
	 dw   120,140

;------------------------------------------------------

;᮪   ah (  뢠 ᮤন al):
psubtbl dw offset reset    ;0 -  ணࠬ
	dw offset swrC1    ;1 -  1
	dw offset srdC1    ;2 - ⥭ 1
	dw offset swrC2    ;3 -  2
	dw offset sempty
	dw offset swrP1    ;5 -  1
	dw offset swrIR    ;6 -  22
	dw offset swrP2    ;7 -  2
	dw offset srdstate ;8 -   ﭨ
	dw offset swrA1    ;9 -  1
	dw offset srdA1    ;A - ⥭ 1
	dw offset swrA2    ;B -  2
	dw offset sempty
	dw offset swrB1    ;D -  1
	dw offset srdB1    ;E - ⥭ 1
	dw offset swrB2    ;F -  2
rgdtbl	dw 0
rgdC1	dw 0  ;1 -  1
	dw 0
rgdC2	dw 0  ;3 -  2
	dw 0
rgdP1	dw 0  ;5 -  1
rgdIR	dw 0  ;6 -  22
rgdP2	dw 0  ;7 -  2
	dw 0
rgdA1	dw 0  ;9 -  1
	dw 0
rgdA2	dw 0  ;B -  2
	dw 0
rgdB1	dw 0  ;D -  1
	dw 0
rgdB2	dw 0  ;F -  2



;80h  TSTOFF ⪫ ஢ । ﭨ (128)

port	proc near
	mov	 bl,ah
	and	 bl,0Fh
	xor	 bh,bh
	add	 bx,bx
	add	 bx,offset psubtbl
	jmp	 cs:[bx]
sempty: mov	 al,0
portret:
	ret


;0 -   ﭨ
srdstate:
	mov	 dx,cs:_portaddr	    ;   LPT
	inc	 dx
	in	 al,dx	    ;379A -  ஫ ணࠬ
	in	al,dx	    ;ArAnd
	ret

swrA1:	  ;9 -  1
swrB1:	  ;D -  1
swrC1:	  ;1 -  1
swrA2:	  ;B -  2
swrB2:	  ;F -  2
swrC2:	  ;3 -  2
swrIR:	  ;6 -  22
	add bx,rgdtbl-psubtbl  ; 㪠⥫  rgdtbl
	test	 ah,80h       ; ஢ઠ 襣 
	jnz	 flwr	      ; ᫨  7 ⠭,    ஢ન
	cmp	 byte ptr cs:[bx],al
	jz	 portret      ; ᫨       
flwr:	mov	 byte ptr cs:[bx],al   ; ࠭  祭

writerg:
	mov	 dx,cs:_portaddr	;   LPT
	out	 dx,al		; out data
	inc	 dx
	inc	 dx
	mov	 al,ah
	and	 al,0dfh	;ArAnd 5-   -> 
	out	 dx,al		; out control
	and	 al,0Ch 	;    ஬ 
	out	 dx,al
	ret

swrP1:	  ;5 -  1
	mov	 byte ptr cs:rgdP1,al
	mov	 byte ptr cs:rgdA1,0
	mov	 byte ptr cs:rgdB1,0
	mov	 byte ptr cs:rgdC1,0
	jmp	 writerg
swrP2:	  ;7 -  2
	mov	 byte ptr cs:rgdP2,al
	mov	 byte ptr cs:rgdA2,0
	mov	 byte ptr cs:rgdB2,0
	mov	 byte ptr cs:rgdC2,0
	jmp	 writerg

srdA1:	  ;A - ⥭ 1
srdB1:	  ;E - ⥭ 1
srdC1:	  ;2 - ⥭ 1
readrg:
	mov	 dx,cs:_portaddr	    ;   LPT
	inc	 dx
	inc	 dx
	mov	 al,ah
	or	 al,20h 	    ;ArAnd  
	out	 dx,al
	dec	 dx
	dec	 dx
	in	 al,dx
	in	 al,dx		    ;ArAnd
	xchg	 al,ah		    ;378h - ⠭ 
	inc	 dx
	inc	 dx
	and	 al,0Ch 	    ;   ஬ 
	out	 dx,al
	mov	 al,ah
	ret

reset:
	mov	 ax,859Bh    ;⠭ 1  In_In_In
	call	 port	     ; ஢ન । ﭨ

	mov	 ax,8790h    ;⠭ 2  In_Out_Out
	call	 port

	mov	 ax,83CFh    ;殮  min
	call	 port

	mov	 ax,8600h    ;⠭  "0" 22
	call	 port
	ret

	endp

;================================================
; low level fun
_bdport	proc near CMD:word
	push	dx
	mov	ax,CMD
	call	port
	pop	dx
	ret
	endp

;================================================
; ⠭   0/1
;setpin	proc far PIN:word,STATE:word
;
;	mov	cx,PIN
;	mov	ax,STATE
;...
;	mov	ax,0		  ; OK
;	ret
;	endp
;================================================
; ⥭ ﭨ , ret: 0/1
;getpin	proc far PIN:word
;	mov	cx,PIN
;..
;	mov	ax,0
;	ret
;	endp

;================================================
; test hardware
testhard proc near
	mov	dx,cs:_portaddr
				;ArAnd
	inc	dx
	inc	dx
	in	al,dx
	and	al,0dfh 	;5   ->  뢮
	out	dx,al
	dec	dx
	dec	dx
				;ArAnd
	mov	bh,88h
	mov	al,bh
	out	dx,al			;88h
	xor	ch,ch		;⪠ ॣ १ 
	in	al,dx		;, ...    88h
	cmp	al,bh		;ࠢ  室
	call	sdv		;ᤢ   䫠 ZF 訬 ࠧ冷
				; ॣ CH
				;bh=88h -   ⮬,  ᫥騬 ⮬
				; IR=1  /S7=1 
	mov	al,06h		;A1P=A0P=WR=1,RD=0   IR=1 ?
	inc	dx
	inc	dx
	out	dx,al		;37A
	dec	dx		;379
	in	al,dx
	and	al,0F8h 	;S0...S2  ࠧ 稯  ᥡ  ࠧ
	xor	bh,al		; bh IR  S7 ⥯ ந஢.
				; 쭮 ⠭. 0-⮬  
				;⢥⮣   ZF=1,  , 
				;  ᠬ  ந  ࠧ.
	test	bh,0B0h 	;pin 11-13 Lpt     (;)
	call	sdv		;ᠫ  .   - 㫨  ZF=1
	test	al,40h		;power (LPT pin10 - ACK - IRQ)
	call	sdv
	mov	al,7		;WR=RD=0 A0=A1=1  IR=0
	call	oai9		;O_utput 37_a I_nput 37_9
	mov	al,4		;WR=RD=A0=A1=1	IR=0
	call	oai9		;RD=1
	mov	al,2		;WR=1 RD=A0=0 A1=1 IR=0
	call	oai9		;A0=0 - ⠪ 㬠
;砫쭮  - ஢ઠ ࠡ DD2C DD3A DD3C  VD5.
;     浪, ᫨ 拉  奬,
; ⠪  ॡ 権   ...
	mov	al,0Eh		;WR=1 RD=0 A0=1 A1=0	IR=0
	call	oai9		;A1=0
	test	bh,8		;IR  ᠬ  ஢ન 6-
	call	sdv
	inc	dx
	mov	al,2Ch		;⠭ ﭨ 
				; 設    
	out	dx,al
	mov	al,0FFh
	xor	al,ch		; invert error mask
	ret

oai9:
	inc	dx
	out	dx,al
	dec	dx
	in	al,dx
	and	al,8
	call	sdv
	ret

sdv:	lahf				;AH=flags
	shl	ah,2
	rcl	ch,1			;ch.0=⥪ 訡
	ret

	endp

;================================================
; 樠
; reset hardware
_init	proc near


if ECPEPP
;ArAnd -  ० "ECP+EPP"  "Extended":
;Bidirectional
	mov	dx,cs:_portaddr
	add	dx,402h 	;ECR_BASE
	in	al,dx
	and	al,1fh
;	 or	 al,80h 	 ;EPP
	or	al,20h		 ;Bidirect
	out	dx,al

endif ;ECPEPP


	call	 testhard	 ; test hardware
	jnz	 ini_er

	mov	 ax,0000h	 ; reset hardware
	call	 port
ini_ok:
	mov	 ax,0 ;OK
	ret
ini_er:
	mov	 ah,1 ;Error
	ret

	endp
;==========================================================
;    殮
; 롨ࠥ ࠢ  襥 襥 祭
; [bx] - ⠡ 殮
findvlt proc near
	or   ax,ax
	jz   fndvl3
	mov  cx,cs:[bx]
	add  bx,cx
	add  bx,cx  ;   ⠡

fndvl:
	or   cx,cx  ; 砫 ⠡ ?
	jz   fndvl2
	dec  cx
	cmp  ax,cs:[bx] ; <= ?
	jnc  fndvl2
	dec  bx
	dec  bx
	jmp  fndvl
fndvl2: mov  ax,cx
fndvl3: ret

	endp


; ⠭ 殮:
; D7,D6,D5,D4,D3,D2,D1,D0
; p0 i0 c1 c0 p4 p3 p2 p1

_voltage proc near Vcc:word,Vpp:word,Vid:word
	mov	cs:voltbyte,0

	mov	ax,Vcc
	mov	bx,offset VccTable
	call	findvlt
	shl	al,4
	or	cs:voltbyte,al

	mov	ax,Vpp
	mov	bx,offset VppTable
	call	findvlt
	mov	bx,offset tVppCode
	xor	ah,ah
	add	bx,ax
	mov	al,cs:[bx]
	or	cs:voltbyte,al

	mov	ax,Vid
	mov	bx,offset VidTable
	call	findvlt
	xor	al,1
	shl	al,6
	or	cs:voltbyte,al

	mov	al,cs:voltbyte
	mov	ah,083h ;  殮  ⠡
	call	port
	mov	ax,0 ;OK
	ret
	endp


;================================================
voltbyte db 0

;   殮 Vpp:

tVppCode  db   10001111b, 10001110b, 10001101b, 10001100b ; 55, 65, 75, 85
	  db   10001011b, 10001010b, 00001111b, 10001001b ; 95,105,110,115
	  db   00001110b, 10001000b, 00001101b, 10000111b ;120,125,130,135
	  db   00001100b, 10000110b, 00001011b, 10000101b ;140,145,150,155
	  db   00001010b, 10000100b, 00001001b, 10000011b ;160,165,170,175
	  db   00001000b, 10000010b, 00000111b, 10000001b ;180,185,190,195
	  db   00000110b, 10000000b, 00000101b, 00000100b ;200,205,210,220
	  db   00000011b, 00000010b, 00000001b, 00000000b ;230,240,250,260

;	 db "BiDiPro hardware driver r1.3 v1.2",0
;	 db  ??date,0

	.data

_portaddr	dw	0	; hardware port adr - set by main program

	END

;--------------------------------------------------------------------------
; E0F
;--------------------------------------------------------------------------

