/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* BiDiPro/AVR v0.1.0                                                 cmds.h
* Copyright (c) Oleg O. Chukaev, 2007, 2008  <oleg.chukaev@mail.ru>
* Based on AVRPP - AVR Parallel Programming Controller  R0.39 (C)ChaN, 2007
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/


#ifndef AVR_CMDS_H
#define AVR_CMDS_H


/* Device programming commands */
#define C_NOP		0x00
#define C_ERASE		0x80
#define C_WR_PRG	0x10
#define C_RD_PRG	0x02
#define C_WR_EEP	0x11
#define C_RD_EEP	0x03
#define C_WR_FB		0x40
#define C_RD_FB		0x04
#define C_WR_LB		0x20
#define C_RD_SIG	0x08

#define	I_LDCMD		0x4C
#define	I_LDAL		0x0C
#define	I_LDAH		0x1C
#define	I_LDDL		0x2C
#define	I_LDDH		0x3C
#define	I_PSTL1		0x6D
#define	I_PSTL2		0x6C
#define	I_PSTH1		0x7D
#define	I_PSTH2		0x7C
#define	I_RDLL1		0x68
#define	I_RDLL2		0x6C
#define	I_RDLH1		0x78
#define	I_RDLH2		0x7C
#define	I_RDHL1		0x6A
#define	I_RDHL2		0x6E
#define	I_RDHH1		0x7A
#define	I_RDHH2		0x7E
#define	I_WRLL1		0x64
#define	I_WRLL2		0x6C
#define	I_WRLH1		0x74
#define	I_WRLH2		0x7C
#define	I_WRHL1		0x66
#define	I_WRHL2		0x6E


/* Device programming commands */

#define ISP_C_EN_PRG1	0xAC
#define ISP_C_EN_PRG2	0x53
#define ISP_C_ERASE1	0xAC
#define ISP_C_ERASE2	0x80
#define ISP_C_LD_ADRX	0x4D
#define ISP_C_WR_PRGL	0x40
#define ISP_C_WR_PRGH	0x48
#define ISP_C_WR_PAGE	0x4C
#define ISP_C_RD_PRGL	0x20
#define ISP_C_RD_PRGH	0x28
#define ISP_C_WR_EEP	0xC0
#define ISP_C_RD_EEP	0xA0
#define ISP_C_WR_FLB	0xAC
#define ISP_C_WR_FLBL	0xA0
#define ISP_C_WR_FLBH	0xA8
#define ISP_C_WR_FLBX	0xA4
#define ISP_C_WR_FLBK	0xE0
#define ISP_C_RD_FLB1	0x58
#define ISP_C_RD_FB1	0x50
#define ISP_C_RD_SIG	0x30
#define ISP_C_RD_CAL	0x38


#endif /* AVR_CMDS_H */

/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* E0F
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/

