/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* BiDiPro/AVR v0.1.0                                              defines.h
* Copyright (c) Oleg O. Chukaev, 2007, 2008 <oleg.chukaev@mail.ru>
* Based on AVRPP - AVR Parallel Programming Controller  R0.39 (C)ChaN, 2007
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/


#ifndef AVR_DEFINES_H
#define AVR_DEFINES_H


#ifndef MAXPATH
# define MAXPATH 80
#endif

#ifndef NELEMS
# define NELEMS(array)	(sizeof(array) / sizeof(array[0]))
#endif

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;


/*  / /祭 */
#define	DEVICE_FOUND	0
#define	DEVICE_UNKNOWN	1
#define	DEVICE_LOCKED	2


/* ࠬ dst  write_buffer() */
#define WR_HEX_STDOUT	0
#define WR_HEX_FILE	1
#define WR_BIN_FILE	2


/* ࠬ type  read_file() */
#define RD_HEX_FILE	1
#define RD_BIN_FILE	2


/*  . 䠩 */
#define FUSEFILE  "fuses.cfg"
#define CHIPSFILE "chips.cfg"
#define INIFILE   "avrc.cfg"


/* Program return codes */
#define	RC_SUCCESS	0
#define	RC_FAIL		1
#define	RC_FILE		2
#define	RC_INIT		3
#define RC_DEV		4
#define	RC_SYNTAX	5


/* Buffer size for flash/eeprom */
/* #define	MAX_FLASH	(256*1024L) */
#define	MAX_FLASH	(32768L)
#define	MAX_EEPROM	(  4*1024L)


/* ᨬ쭮 ᫮ ন  */
#define MAX_DEVICES	400


/* ᨬ쭮 - fuse+lock ⮢ */
#define MAX_FUSES	32


#endif /* AVR_DEFINES_H */

/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* E0F
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/
